<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightInfo
 * @subpackage Arrays
 */
class ArrayOfFlightInfo extends AbstractStructArrayBase
{
    /**
     * The FlightInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FlightInfo[]
     */
    public $FlightInfo;
    /**
     * Constructor method for ArrayOfFlightInfo
     * @uses ArrayOfFlightInfo::setFlightInfo()
     * @param \StructType\FlightInfo[] $flightInfo
     */
    public function __construct(array $flightInfo = array())
    {
        $this
            ->setFlightInfo($flightInfo);
    }
    /**
     * Get FlightInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FlightInfo[]|null
     */
    public function getFlightInfo()
    {
        return isset($this->FlightInfo) ? $this->FlightInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightInfoForArrayConstraintsFromSetFlightInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFlightInfoFlightInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightInfoFlightInfoItem instanceof \StructType\FlightInfo) {
                $invalidValues[] = is_object($arrayOfFlightInfoFlightInfoItem) ? get_class($arrayOfFlightInfoFlightInfoItem) : sprintf('%s(%s)', gettype($arrayOfFlightInfoFlightInfoItem), var_export($arrayOfFlightInfoFlightInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightInfo property can only contain items of type \StructType\FlightInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FlightInfo[] $flightInfo
     * @return \ArrayType\ArrayOfFlightInfo
     */
    public function setFlightInfo(array $flightInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($flightInfoArrayErrorMessage = self::validateFlightInfoForArrayConstraintsFromSetFlightInfo($flightInfo))) {
            throw new \InvalidArgumentException($flightInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($flightInfo) || (is_array($flightInfo) && empty($flightInfo))) {
            unset($this->FlightInfo);
        } else {
            $this->FlightInfo = $flightInfo;
        }
        return $this;
    }
    /**
     * Add item to FlightInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightInfo $item
     * @return \ArrayType\ArrayOfFlightInfo
     */
    public function addToFlightInfo(\StructType\FlightInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightInfo) {
            throw new \InvalidArgumentException(sprintf('The FlightInfo property can only contain items of type \StructType\FlightInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FlightInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FlightInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FlightInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FlightInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FlightInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightInfo
     */
    public function getAttributeName()
    {
        return 'FlightInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFlightInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
