<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightService ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightService
 * @subpackage Arrays
 */
class ArrayOfFlightService extends AbstractStructArrayBase
{
    /**
     * The FlightService
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FlightService[]
     */
    public $FlightService;
    /**
     * Constructor method for ArrayOfFlightService
     * @uses ArrayOfFlightService::setFlightService()
     * @param \StructType\FlightService[] $flightService
     */
    public function __construct(array $flightService = array())
    {
        $this
            ->setFlightService($flightService);
    }
    /**
     * Get FlightService value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FlightService[]|null
     */
    public function getFlightService()
    {
        return isset($this->FlightService) ? $this->FlightService : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightServiceForArrayConstraintsFromSetFlightService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFlightServiceFlightServiceItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightServiceFlightServiceItem instanceof \StructType\FlightService) {
                $invalidValues[] = is_object($arrayOfFlightServiceFlightServiceItem) ? get_class($arrayOfFlightServiceFlightServiceItem) : sprintf('%s(%s)', gettype($arrayOfFlightServiceFlightServiceItem), var_export($arrayOfFlightServiceFlightServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightService property can only contain items of type \StructType\FlightService, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightService value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FlightService[] $flightService
     * @return \ArrayType\ArrayOfFlightService
     */
    public function setFlightService(array $flightService = array())
    {
        // validation for constraint: array
        if ('' !== ($flightServiceArrayErrorMessage = self::validateFlightServiceForArrayConstraintsFromSetFlightService($flightService))) {
            throw new \InvalidArgumentException($flightServiceArrayErrorMessage, __LINE__);
        }
        if (is_null($flightService) || (is_array($flightService) && empty($flightService))) {
            unset($this->FlightService);
        } else {
            $this->FlightService = $flightService;
        }
        return $this;
    }
    /**
     * Add item to FlightService value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightService $item
     * @return \ArrayType\ArrayOfFlightService
     */
    public function addToFlightService(\StructType\FlightService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightService) {
            throw new \InvalidArgumentException(sprintf('The FlightService property can only contain items of type \StructType\FlightService, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightService[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FlightService|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FlightService|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FlightService|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FlightService|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FlightService|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightService
     */
    public function getAttributeName()
    {
        return 'FlightService';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFlightService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
