<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelRoomPrice ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelRoomPrice
 * @subpackage Arrays
 */
class ArrayOfHotelRoomPrice extends AbstractStructArrayBase
{
    /**
     * The HotelRoomPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelRoomPrice[]
     */
    public $HotelRoomPrice;
    /**
     * Constructor method for ArrayOfHotelRoomPrice
     * @uses ArrayOfHotelRoomPrice::setHotelRoomPrice()
     * @param \StructType\HotelRoomPrice[] $hotelRoomPrice
     */
    public function __construct(array $hotelRoomPrice = array())
    {
        $this
            ->setHotelRoomPrice($hotelRoomPrice);
    }
    /**
     * Get HotelRoomPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelRoomPrice[]|null
     */
    public function getHotelRoomPrice()
    {
        return isset($this->HotelRoomPrice) ? $this->HotelRoomPrice : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelRoomPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelRoomPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelRoomPriceForArrayConstraintsFromSetHotelRoomPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHotelRoomPriceHotelRoomPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelRoomPriceHotelRoomPriceItem instanceof \StructType\HotelRoomPrice) {
                $invalidValues[] = is_object($arrayOfHotelRoomPriceHotelRoomPriceItem) ? get_class($arrayOfHotelRoomPriceHotelRoomPriceItem) : sprintf('%s(%s)', gettype($arrayOfHotelRoomPriceHotelRoomPriceItem), var_export($arrayOfHotelRoomPriceHotelRoomPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelRoomPrice property can only contain items of type \StructType\HotelRoomPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelRoomPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelRoomPrice[] $hotelRoomPrice
     * @return \ArrayType\ArrayOfHotelRoomPrice
     */
    public function setHotelRoomPrice(array $hotelRoomPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelRoomPriceArrayErrorMessage = self::validateHotelRoomPriceForArrayConstraintsFromSetHotelRoomPrice($hotelRoomPrice))) {
            throw new \InvalidArgumentException($hotelRoomPriceArrayErrorMessage, __LINE__);
        }
        if (is_null($hotelRoomPrice) || (is_array($hotelRoomPrice) && empty($hotelRoomPrice))) {
            unset($this->HotelRoomPrice);
        } else {
            $this->HotelRoomPrice = $hotelRoomPrice;
        }
        return $this;
    }
    /**
     * Add item to HotelRoomPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelRoomPrice $item
     * @return \ArrayType\ArrayOfHotelRoomPrice
     */
    public function addToHotelRoomPrice(\StructType\HotelRoomPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelRoomPrice) {
            throw new \InvalidArgumentException(sprintf('The HotelRoomPrice property can only contain items of type \StructType\HotelRoomPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelRoomPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelRoomPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelRoomPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelRoomPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelRoomPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelRoomPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelRoomPrice
     */
    public function getAttributeName()
    {
        return 'HotelRoomPrice';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelRoomPrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
