<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPricePerAccmd ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPricePerAccmd
 * @subpackage Arrays
 */
class ArrayOfPricePerAccmd extends AbstractStructArrayBase
{
    /**
     * The PricePerAccmd
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PricePerAccmd[]
     */
    public $PricePerAccmd;
    /**
     * Constructor method for ArrayOfPricePerAccmd
     * @uses ArrayOfPricePerAccmd::setPricePerAccmd()
     * @param \StructType\PricePerAccmd[] $pricePerAccmd
     */
    public function __construct(array $pricePerAccmd = array())
    {
        $this
            ->setPricePerAccmd($pricePerAccmd);
    }
    /**
     * Get PricePerAccmd value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PricePerAccmd[]|null
     */
    public function getPricePerAccmd()
    {
        return isset($this->PricePerAccmd) ? $this->PricePerAccmd : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPricePerAccmd method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPricePerAccmd method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePricePerAccmdForArrayConstraintsFromSetPricePerAccmd(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPricePerAccmdPricePerAccmdItem) {
            // validation for constraint: itemType
            if (!$arrayOfPricePerAccmdPricePerAccmdItem instanceof \StructType\PricePerAccmd) {
                $invalidValues[] = is_object($arrayOfPricePerAccmdPricePerAccmdItem) ? get_class($arrayOfPricePerAccmdPricePerAccmdItem) : sprintf('%s(%s)', gettype($arrayOfPricePerAccmdPricePerAccmdItem), var_export($arrayOfPricePerAccmdPricePerAccmdItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PricePerAccmd property can only contain items of type \StructType\PricePerAccmd, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PricePerAccmd value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PricePerAccmd[] $pricePerAccmd
     * @return \ArrayType\ArrayOfPricePerAccmd
     */
    public function setPricePerAccmd(array $pricePerAccmd = array())
    {
        // validation for constraint: array
        if ('' !== ($pricePerAccmdArrayErrorMessage = self::validatePricePerAccmdForArrayConstraintsFromSetPricePerAccmd($pricePerAccmd))) {
            throw new \InvalidArgumentException($pricePerAccmdArrayErrorMessage, __LINE__);
        }
        if (is_null($pricePerAccmd) || (is_array($pricePerAccmd) && empty($pricePerAccmd))) {
            unset($this->PricePerAccmd);
        } else {
            $this->PricePerAccmd = $pricePerAccmd;
        }
        return $this;
    }
    /**
     * Add item to PricePerAccmd value
     * @throws \InvalidArgumentException
     * @param \StructType\PricePerAccmd $item
     * @return \ArrayType\ArrayOfPricePerAccmd
     */
    public function addToPricePerAccmd(\StructType\PricePerAccmd $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PricePerAccmd) {
            throw new \InvalidArgumentException(sprintf('The PricePerAccmd property can only contain items of type \StructType\PricePerAccmd, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PricePerAccmd[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PricePerAccmd|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PricePerAccmd|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PricePerAccmd|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PricePerAccmd|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PricePerAccmd|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PricePerAccmd
     */
    public function getAttributeName()
    {
        return 'PricePerAccmd';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPricePerAccmd
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
