<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuotaDateState ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQuotaDateState
 * @subpackage Arrays
 */
class ArrayOfQuotaDateState extends AbstractStructArrayBase
{
    /**
     * The QuotaDateState
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuotaDateState[]
     */
    public $QuotaDateState;
    /**
     * Constructor method for ArrayOfQuotaDateState
     * @uses ArrayOfQuotaDateState::setQuotaDateState()
     * @param \StructType\QuotaDateState[] $quotaDateState
     */
    public function __construct(array $quotaDateState = array())
    {
        $this
            ->setQuotaDateState($quotaDateState);
    }
    /**
     * Get QuotaDateState value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuotaDateState[]|null
     */
    public function getQuotaDateState()
    {
        return isset($this->QuotaDateState) ? $this->QuotaDateState : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQuotaDateState method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuotaDateState method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuotaDateStateForArrayConstraintsFromSetQuotaDateState(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuotaDateStateQuotaDateStateItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuotaDateStateQuotaDateStateItem instanceof \StructType\QuotaDateState) {
                $invalidValues[] = is_object($arrayOfQuotaDateStateQuotaDateStateItem) ? get_class($arrayOfQuotaDateStateQuotaDateStateItem) : sprintf('%s(%s)', gettype($arrayOfQuotaDateStateQuotaDateStateItem), var_export($arrayOfQuotaDateStateQuotaDateStateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuotaDateState property can only contain items of type \StructType\QuotaDateState, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuotaDateState value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaDateState[] $quotaDateState
     * @return \ArrayType\ArrayOfQuotaDateState
     */
    public function setQuotaDateState(array $quotaDateState = array())
    {
        // validation for constraint: array
        if ('' !== ($quotaDateStateArrayErrorMessage = self::validateQuotaDateStateForArrayConstraintsFromSetQuotaDateState($quotaDateState))) {
            throw new \InvalidArgumentException($quotaDateStateArrayErrorMessage, __LINE__);
        }
        if (is_null($quotaDateState) || (is_array($quotaDateState) && empty($quotaDateState))) {
            unset($this->QuotaDateState);
        } else {
            $this->QuotaDateState = $quotaDateState;
        }
        return $this;
    }
    /**
     * Add item to QuotaDateState value
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaDateState $item
     * @return \ArrayType\ArrayOfQuotaDateState
     */
    public function addToQuotaDateState(\StructType\QuotaDateState $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuotaDateState) {
            throw new \InvalidArgumentException(sprintf('The QuotaDateState property can only contain items of type \StructType\QuotaDateState, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuotaDateState[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuotaDateState|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuotaDateState|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuotaDateState|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuotaDateState|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuotaDateState|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuotaDateState
     */
    public function getAttributeName()
    {
        return 'QuotaDateState';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQuotaDateState
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
