<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuotaFlightItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQuotaFlightItem
 * @subpackage Arrays
 */
class ArrayOfQuotaFlightItem extends AbstractStructArrayBase
{
    /**
     * The QuotaFlightItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuotaFlightItem[]
     */
    public $QuotaFlightItem;
    /**
     * Constructor method for ArrayOfQuotaFlightItem
     * @uses ArrayOfQuotaFlightItem::setQuotaFlightItem()
     * @param \StructType\QuotaFlightItem[] $quotaFlightItem
     */
    public function __construct(array $quotaFlightItem = array())
    {
        $this
            ->setQuotaFlightItem($quotaFlightItem);
    }
    /**
     * Get QuotaFlightItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuotaFlightItem[]|null
     */
    public function getQuotaFlightItem()
    {
        return isset($this->QuotaFlightItem) ? $this->QuotaFlightItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQuotaFlightItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuotaFlightItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuotaFlightItemForArrayConstraintsFromSetQuotaFlightItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuotaFlightItemQuotaFlightItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuotaFlightItemQuotaFlightItemItem instanceof \StructType\QuotaFlightItem) {
                $invalidValues[] = is_object($arrayOfQuotaFlightItemQuotaFlightItemItem) ? get_class($arrayOfQuotaFlightItemQuotaFlightItemItem) : sprintf('%s(%s)', gettype($arrayOfQuotaFlightItemQuotaFlightItemItem), var_export($arrayOfQuotaFlightItemQuotaFlightItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuotaFlightItem property can only contain items of type \StructType\QuotaFlightItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuotaFlightItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaFlightItem[] $quotaFlightItem
     * @return \ArrayType\ArrayOfQuotaFlightItem
     */
    public function setQuotaFlightItem(array $quotaFlightItem = array())
    {
        // validation for constraint: array
        if ('' !== ($quotaFlightItemArrayErrorMessage = self::validateQuotaFlightItemForArrayConstraintsFromSetQuotaFlightItem($quotaFlightItem))) {
            throw new \InvalidArgumentException($quotaFlightItemArrayErrorMessage, __LINE__);
        }
        if (is_null($quotaFlightItem) || (is_array($quotaFlightItem) && empty($quotaFlightItem))) {
            unset($this->QuotaFlightItem);
        } else {
            $this->QuotaFlightItem = $quotaFlightItem;
        }
        return $this;
    }
    /**
     * Add item to QuotaFlightItem value
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaFlightItem $item
     * @return \ArrayType\ArrayOfQuotaFlightItem
     */
    public function addToQuotaFlightItem(\StructType\QuotaFlightItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuotaFlightItem) {
            throw new \InvalidArgumentException(sprintf('The QuotaFlightItem property can only contain items of type \StructType\QuotaFlightItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuotaFlightItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuotaFlightItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuotaFlightItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuotaFlightItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuotaFlightItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuotaFlightItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuotaFlightItem
     */
    public function getAttributeName()
    {
        return 'QuotaFlightItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQuotaFlightItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
