<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuotaFlightTariffState ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQuotaFlightTariffState
 * @subpackage Arrays
 */
class ArrayOfQuotaFlightTariffState extends AbstractStructArrayBase
{
    /**
     * The QuotaFlightTariffState
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuotaFlightTariffState[]
     */
    public $QuotaFlightTariffState;
    /**
     * Constructor method for ArrayOfQuotaFlightTariffState
     * @uses ArrayOfQuotaFlightTariffState::setQuotaFlightTariffState()
     * @param \StructType\QuotaFlightTariffState[] $quotaFlightTariffState
     */
    public function __construct(array $quotaFlightTariffState = array())
    {
        $this
            ->setQuotaFlightTariffState($quotaFlightTariffState);
    }
    /**
     * Get QuotaFlightTariffState value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuotaFlightTariffState[]|null
     */
    public function getQuotaFlightTariffState()
    {
        return isset($this->QuotaFlightTariffState) ? $this->QuotaFlightTariffState : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQuotaFlightTariffState method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuotaFlightTariffState method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuotaFlightTariffStateForArrayConstraintsFromSetQuotaFlightTariffState(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuotaFlightTariffStateQuotaFlightTariffStateItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuotaFlightTariffStateQuotaFlightTariffStateItem instanceof \StructType\QuotaFlightTariffState) {
                $invalidValues[] = is_object($arrayOfQuotaFlightTariffStateQuotaFlightTariffStateItem) ? get_class($arrayOfQuotaFlightTariffStateQuotaFlightTariffStateItem) : sprintf('%s(%s)', gettype($arrayOfQuotaFlightTariffStateQuotaFlightTariffStateItem), var_export($arrayOfQuotaFlightTariffStateQuotaFlightTariffStateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuotaFlightTariffState property can only contain items of type \StructType\QuotaFlightTariffState, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuotaFlightTariffState value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaFlightTariffState[] $quotaFlightTariffState
     * @return \ArrayType\ArrayOfQuotaFlightTariffState
     */
    public function setQuotaFlightTariffState(array $quotaFlightTariffState = array())
    {
        // validation for constraint: array
        if ('' !== ($quotaFlightTariffStateArrayErrorMessage = self::validateQuotaFlightTariffStateForArrayConstraintsFromSetQuotaFlightTariffState($quotaFlightTariffState))) {
            throw new \InvalidArgumentException($quotaFlightTariffStateArrayErrorMessage, __LINE__);
        }
        if (is_null($quotaFlightTariffState) || (is_array($quotaFlightTariffState) && empty($quotaFlightTariffState))) {
            unset($this->QuotaFlightTariffState);
        } else {
            $this->QuotaFlightTariffState = $quotaFlightTariffState;
        }
        return $this;
    }
    /**
     * Add item to QuotaFlightTariffState value
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaFlightTariffState $item
     * @return \ArrayType\ArrayOfQuotaFlightTariffState
     */
    public function addToQuotaFlightTariffState(\StructType\QuotaFlightTariffState $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuotaFlightTariffState) {
            throw new \InvalidArgumentException(sprintf('The QuotaFlightTariffState property can only contain items of type \StructType\QuotaFlightTariffState, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuotaFlightTariffState[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuotaFlightTariffState|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuotaFlightTariffState|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuotaFlightTariffState|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuotaFlightTariffState|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuotaFlightTariffState|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuotaFlightTariffState
     */
    public function getAttributeName()
    {
        return 'QuotaFlightTariffState';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQuotaFlightTariffState
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
