<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuotaFlightTariffs ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQuotaFlightTariffs
 * @subpackage Arrays
 */
class ArrayOfQuotaFlightTariffs extends AbstractStructArrayBase
{
    /**
     * The QuotaFlightTariffs
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuotaFlightTariffs[]
     */
    public $QuotaFlightTariffs;
    /**
     * Constructor method for ArrayOfQuotaFlightTariffs
     * @uses ArrayOfQuotaFlightTariffs::setQuotaFlightTariffs()
     * @param \StructType\QuotaFlightTariffs[] $quotaFlightTariffs
     */
    public function __construct(array $quotaFlightTariffs = array())
    {
        $this
            ->setQuotaFlightTariffs($quotaFlightTariffs);
    }
    /**
     * Get QuotaFlightTariffs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuotaFlightTariffs[]|null
     */
    public function getQuotaFlightTariffs()
    {
        return isset($this->QuotaFlightTariffs) ? $this->QuotaFlightTariffs : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQuotaFlightTariffs method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuotaFlightTariffs method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuotaFlightTariffsForArrayConstraintsFromSetQuotaFlightTariffs(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuotaFlightTariffsQuotaFlightTariffsItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuotaFlightTariffsQuotaFlightTariffsItem instanceof \StructType\QuotaFlightTariffs) {
                $invalidValues[] = is_object($arrayOfQuotaFlightTariffsQuotaFlightTariffsItem) ? get_class($arrayOfQuotaFlightTariffsQuotaFlightTariffsItem) : sprintf('%s(%s)', gettype($arrayOfQuotaFlightTariffsQuotaFlightTariffsItem), var_export($arrayOfQuotaFlightTariffsQuotaFlightTariffsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuotaFlightTariffs property can only contain items of type \StructType\QuotaFlightTariffs, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuotaFlightTariffs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaFlightTariffs[] $quotaFlightTariffs
     * @return \ArrayType\ArrayOfQuotaFlightTariffs
     */
    public function setQuotaFlightTariffs(array $quotaFlightTariffs = array())
    {
        // validation for constraint: array
        if ('' !== ($quotaFlightTariffsArrayErrorMessage = self::validateQuotaFlightTariffsForArrayConstraintsFromSetQuotaFlightTariffs($quotaFlightTariffs))) {
            throw new \InvalidArgumentException($quotaFlightTariffsArrayErrorMessage, __LINE__);
        }
        if (is_null($quotaFlightTariffs) || (is_array($quotaFlightTariffs) && empty($quotaFlightTariffs))) {
            unset($this->QuotaFlightTariffs);
        } else {
            $this->QuotaFlightTariffs = $quotaFlightTariffs;
        }
        return $this;
    }
    /**
     * Add item to QuotaFlightTariffs value
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaFlightTariffs $item
     * @return \ArrayType\ArrayOfQuotaFlightTariffs
     */
    public function addToQuotaFlightTariffs(\StructType\QuotaFlightTariffs $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuotaFlightTariffs) {
            throw new \InvalidArgumentException(sprintf('The QuotaFlightTariffs property can only contain items of type \StructType\QuotaFlightTariffs, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuotaFlightTariffs[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuotaFlightTariffs|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuotaFlightTariffs|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuotaFlightTariffs|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuotaFlightTariffs|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuotaFlightTariffs|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuotaFlightTariffs
     */
    public function getAttributeName()
    {
        return 'QuotaFlightTariffs';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQuotaFlightTariffs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
