<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuotaHotelRoomVariant ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQuotaHotelRoomVariant
 * @subpackage Arrays
 */
class ArrayOfQuotaHotelRoomVariant extends AbstractStructArrayBase
{
    /**
     * The QuotaHotelRoomVariant
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuotaHotelRoomVariant[]
     */
    public $QuotaHotelRoomVariant;
    /**
     * Constructor method for ArrayOfQuotaHotelRoomVariant
     * @uses ArrayOfQuotaHotelRoomVariant::setQuotaHotelRoomVariant()
     * @param \StructType\QuotaHotelRoomVariant[] $quotaHotelRoomVariant
     */
    public function __construct(array $quotaHotelRoomVariant = array())
    {
        $this
            ->setQuotaHotelRoomVariant($quotaHotelRoomVariant);
    }
    /**
     * Get QuotaHotelRoomVariant value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuotaHotelRoomVariant[]|null
     */
    public function getQuotaHotelRoomVariant()
    {
        return isset($this->QuotaHotelRoomVariant) ? $this->QuotaHotelRoomVariant : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQuotaHotelRoomVariant method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuotaHotelRoomVariant method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuotaHotelRoomVariantForArrayConstraintsFromSetQuotaHotelRoomVariant(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuotaHotelRoomVariantQuotaHotelRoomVariantItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuotaHotelRoomVariantQuotaHotelRoomVariantItem instanceof \StructType\QuotaHotelRoomVariant) {
                $invalidValues[] = is_object($arrayOfQuotaHotelRoomVariantQuotaHotelRoomVariantItem) ? get_class($arrayOfQuotaHotelRoomVariantQuotaHotelRoomVariantItem) : sprintf('%s(%s)', gettype($arrayOfQuotaHotelRoomVariantQuotaHotelRoomVariantItem), var_export($arrayOfQuotaHotelRoomVariantQuotaHotelRoomVariantItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuotaHotelRoomVariant property can only contain items of type \StructType\QuotaHotelRoomVariant, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuotaHotelRoomVariant value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaHotelRoomVariant[] $quotaHotelRoomVariant
     * @return \ArrayType\ArrayOfQuotaHotelRoomVariant
     */
    public function setQuotaHotelRoomVariant(array $quotaHotelRoomVariant = array())
    {
        // validation for constraint: array
        if ('' !== ($quotaHotelRoomVariantArrayErrorMessage = self::validateQuotaHotelRoomVariantForArrayConstraintsFromSetQuotaHotelRoomVariant($quotaHotelRoomVariant))) {
            throw new \InvalidArgumentException($quotaHotelRoomVariantArrayErrorMessage, __LINE__);
        }
        if (is_null($quotaHotelRoomVariant) || (is_array($quotaHotelRoomVariant) && empty($quotaHotelRoomVariant))) {
            unset($this->QuotaHotelRoomVariant);
        } else {
            $this->QuotaHotelRoomVariant = $quotaHotelRoomVariant;
        }
        return $this;
    }
    /**
     * Add item to QuotaHotelRoomVariant value
     * @throws \InvalidArgumentException
     * @param \StructType\QuotaHotelRoomVariant $item
     * @return \ArrayType\ArrayOfQuotaHotelRoomVariant
     */
    public function addToQuotaHotelRoomVariant(\StructType\QuotaHotelRoomVariant $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuotaHotelRoomVariant) {
            throw new \InvalidArgumentException(sprintf('The QuotaHotelRoomVariant property can only contain items of type \StructType\QuotaHotelRoomVariant, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuotaHotelRoomVariant[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuotaHotelRoomVariant|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuotaHotelRoomVariant|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuotaHotelRoomVariant|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuotaHotelRoomVariant|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuotaHotelRoomVariant|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuotaHotelRoomVariant
     */
    public function getAttributeName()
    {
        return 'QuotaHotelRoomVariant';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQuotaHotelRoomVariant
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
