<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTourDirection ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTourDirection
 * @subpackage Arrays
 */
class ArrayOfTourDirection extends AbstractStructArrayBase
{
    /**
     * The TourDirection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TourDirection[]
     */
    public $TourDirection;
    /**
     * Constructor method for ArrayOfTourDirection
     * @uses ArrayOfTourDirection::setTourDirection()
     * @param \StructType\TourDirection[] $tourDirection
     */
    public function __construct(array $tourDirection = array())
    {
        $this
            ->setTourDirection($tourDirection);
    }
    /**
     * Get TourDirection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TourDirection[]|null
     */
    public function getTourDirection()
    {
        return isset($this->TourDirection) ? $this->TourDirection : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTourDirection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTourDirection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTourDirectionForArrayConstraintsFromSetTourDirection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTourDirectionTourDirectionItem) {
            // validation for constraint: itemType
            if (!$arrayOfTourDirectionTourDirectionItem instanceof \StructType\TourDirection) {
                $invalidValues[] = is_object($arrayOfTourDirectionTourDirectionItem) ? get_class($arrayOfTourDirectionTourDirectionItem) : sprintf('%s(%s)', gettype($arrayOfTourDirectionTourDirectionItem), var_export($arrayOfTourDirectionTourDirectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TourDirection property can only contain items of type \StructType\TourDirection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TourDirection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TourDirection[] $tourDirection
     * @return \ArrayType\ArrayOfTourDirection
     */
    public function setTourDirection(array $tourDirection = array())
    {
        // validation for constraint: array
        if ('' !== ($tourDirectionArrayErrorMessage = self::validateTourDirectionForArrayConstraintsFromSetTourDirection($tourDirection))) {
            throw new \InvalidArgumentException($tourDirectionArrayErrorMessage, __LINE__);
        }
        if (is_null($tourDirection) || (is_array($tourDirection) && empty($tourDirection))) {
            unset($this->TourDirection);
        } else {
            $this->TourDirection = $tourDirection;
        }
        return $this;
    }
    /**
     * Add item to TourDirection value
     * @throws \InvalidArgumentException
     * @param \StructType\TourDirection $item
     * @return \ArrayType\ArrayOfTourDirection
     */
    public function addToTourDirection(\StructType\TourDirection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TourDirection) {
            throw new \InvalidArgumentException(sprintf('The TourDirection property can only contain items of type \StructType\TourDirection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TourDirection[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TourDirection|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TourDirection|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TourDirection|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TourDirection|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TourDirection|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TourDirection
     */
    public function getAttributeName()
    {
        return 'TourDirection';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTourDirection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
