<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTourHotelGroup ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTourHotelGroup
 * @subpackage Arrays
 */
class ArrayOfTourHotelGroup extends AbstractStructArrayBase
{
    /**
     * The TourHotelGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TourHotelGroup[]
     */
    public $TourHotelGroup;
    /**
     * Constructor method for ArrayOfTourHotelGroup
     * @uses ArrayOfTourHotelGroup::setTourHotelGroup()
     * @param \StructType\TourHotelGroup[] $tourHotelGroup
     */
    public function __construct(array $tourHotelGroup = array())
    {
        $this
            ->setTourHotelGroup($tourHotelGroup);
    }
    /**
     * Get TourHotelGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TourHotelGroup[]|null
     */
    public function getTourHotelGroup()
    {
        return isset($this->TourHotelGroup) ? $this->TourHotelGroup : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTourHotelGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTourHotelGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTourHotelGroupForArrayConstraintsFromSetTourHotelGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTourHotelGroupTourHotelGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfTourHotelGroupTourHotelGroupItem instanceof \StructType\TourHotelGroup) {
                $invalidValues[] = is_object($arrayOfTourHotelGroupTourHotelGroupItem) ? get_class($arrayOfTourHotelGroupTourHotelGroupItem) : sprintf('%s(%s)', gettype($arrayOfTourHotelGroupTourHotelGroupItem), var_export($arrayOfTourHotelGroupTourHotelGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TourHotelGroup property can only contain items of type \StructType\TourHotelGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TourHotelGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TourHotelGroup[] $tourHotelGroup
     * @return \ArrayType\ArrayOfTourHotelGroup
     */
    public function setTourHotelGroup(array $tourHotelGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($tourHotelGroupArrayErrorMessage = self::validateTourHotelGroupForArrayConstraintsFromSetTourHotelGroup($tourHotelGroup))) {
            throw new \InvalidArgumentException($tourHotelGroupArrayErrorMessage, __LINE__);
        }
        if (is_null($tourHotelGroup) || (is_array($tourHotelGroup) && empty($tourHotelGroup))) {
            unset($this->TourHotelGroup);
        } else {
            $this->TourHotelGroup = $tourHotelGroup;
        }
        return $this;
    }
    /**
     * Add item to TourHotelGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\TourHotelGroup $item
     * @return \ArrayType\ArrayOfTourHotelGroup
     */
    public function addToTourHotelGroup(\StructType\TourHotelGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TourHotelGroup) {
            throw new \InvalidArgumentException(sprintf('The TourHotelGroup property can only contain items of type \StructType\TourHotelGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TourHotelGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TourHotelGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TourHotelGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TourHotelGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TourHotelGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TourHotelGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TourHotelGroup
     */
    public function getAttributeName()
    {
        return 'TourHotelGroup';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTourHotelGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
