<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTourHotelVariant ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTourHotelVariant
 * @subpackage Arrays
 */
class ArrayOfTourHotelVariant extends AbstractStructArrayBase
{
    /**
     * The TourHotelVariant
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TourHotelVariant[]
     */
    public $TourHotelVariant;
    /**
     * Constructor method for ArrayOfTourHotelVariant
     * @uses ArrayOfTourHotelVariant::setTourHotelVariant()
     * @param \StructType\TourHotelVariant[] $tourHotelVariant
     */
    public function __construct(array $tourHotelVariant = array())
    {
        $this
            ->setTourHotelVariant($tourHotelVariant);
    }
    /**
     * Get TourHotelVariant value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TourHotelVariant[]|null
     */
    public function getTourHotelVariant()
    {
        return isset($this->TourHotelVariant) ? $this->TourHotelVariant : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTourHotelVariant method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTourHotelVariant method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTourHotelVariantForArrayConstraintsFromSetTourHotelVariant(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTourHotelVariantTourHotelVariantItem) {
            // validation for constraint: itemType
            if (!$arrayOfTourHotelVariantTourHotelVariantItem instanceof \StructType\TourHotelVariant) {
                $invalidValues[] = is_object($arrayOfTourHotelVariantTourHotelVariantItem) ? get_class($arrayOfTourHotelVariantTourHotelVariantItem) : sprintf('%s(%s)', gettype($arrayOfTourHotelVariantTourHotelVariantItem), var_export($arrayOfTourHotelVariantTourHotelVariantItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TourHotelVariant property can only contain items of type \StructType\TourHotelVariant, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TourHotelVariant value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TourHotelVariant[] $tourHotelVariant
     * @return \ArrayType\ArrayOfTourHotelVariant
     */
    public function setTourHotelVariant(array $tourHotelVariant = array())
    {
        // validation for constraint: array
        if ('' !== ($tourHotelVariantArrayErrorMessage = self::validateTourHotelVariantForArrayConstraintsFromSetTourHotelVariant($tourHotelVariant))) {
            throw new \InvalidArgumentException($tourHotelVariantArrayErrorMessage, __LINE__);
        }
        if (is_null($tourHotelVariant) || (is_array($tourHotelVariant) && empty($tourHotelVariant))) {
            unset($this->TourHotelVariant);
        } else {
            $this->TourHotelVariant = $tourHotelVariant;
        }
        return $this;
    }
    /**
     * Add item to TourHotelVariant value
     * @throws \InvalidArgumentException
     * @param \StructType\TourHotelVariant $item
     * @return \ArrayType\ArrayOfTourHotelVariant
     */
    public function addToTourHotelVariant(\StructType\TourHotelVariant $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TourHotelVariant) {
            throw new \InvalidArgumentException(sprintf('The TourHotelVariant property can only contain items of type \StructType\TourHotelVariant, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TourHotelVariant[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TourHotelVariant|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TourHotelVariant|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TourHotelVariant|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TourHotelVariant|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TourHotelVariant|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TourHotelVariant
     */
    public function getAttributeName()
    {
        return 'TourHotelVariant';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTourHotelVariant
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
