<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTourPriceEx ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTourPriceEx
 * @subpackage Arrays
 */
class ArrayOfTourPriceEx extends AbstractStructArrayBase
{
    /**
     * The TourPriceEx
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TourPriceEx[]
     */
    public $TourPriceEx;
    /**
     * Constructor method for ArrayOfTourPriceEx
     * @uses ArrayOfTourPriceEx::setTourPriceEx()
     * @param \StructType\TourPriceEx[] $tourPriceEx
     */
    public function __construct(array $tourPriceEx = array())
    {
        $this
            ->setTourPriceEx($tourPriceEx);
    }
    /**
     * Get TourPriceEx value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TourPriceEx[]|null
     */
    public function getTourPriceEx()
    {
        return isset($this->TourPriceEx) ? $this->TourPriceEx : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTourPriceEx method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTourPriceEx method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTourPriceExForArrayConstraintsFromSetTourPriceEx(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTourPriceExTourPriceExItem) {
            // validation for constraint: itemType
            if (!$arrayOfTourPriceExTourPriceExItem instanceof \StructType\TourPriceEx) {
                $invalidValues[] = is_object($arrayOfTourPriceExTourPriceExItem) ? get_class($arrayOfTourPriceExTourPriceExItem) : sprintf('%s(%s)', gettype($arrayOfTourPriceExTourPriceExItem), var_export($arrayOfTourPriceExTourPriceExItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TourPriceEx property can only contain items of type \StructType\TourPriceEx, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TourPriceEx value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TourPriceEx[] $tourPriceEx
     * @return \ArrayType\ArrayOfTourPriceEx
     */
    public function setTourPriceEx(array $tourPriceEx = array())
    {
        // validation for constraint: array
        if ('' !== ($tourPriceExArrayErrorMessage = self::validateTourPriceExForArrayConstraintsFromSetTourPriceEx($tourPriceEx))) {
            throw new \InvalidArgumentException($tourPriceExArrayErrorMessage, __LINE__);
        }
        if (is_null($tourPriceEx) || (is_array($tourPriceEx) && empty($tourPriceEx))) {
            unset($this->TourPriceEx);
        } else {
            $this->TourPriceEx = $tourPriceEx;
        }
        return $this;
    }
    /**
     * Add item to TourPriceEx value
     * @throws \InvalidArgumentException
     * @param \StructType\TourPriceEx $item
     * @return \ArrayType\ArrayOfTourPriceEx
     */
    public function addToTourPriceEx(\StructType\TourPriceEx $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TourPriceEx) {
            throw new \InvalidArgumentException(sprintf('The TourPriceEx property can only contain items of type \StructType\TourPriceEx, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TourPriceEx[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TourPriceEx|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TourPriceEx|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TourPriceEx|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TourPriceEx|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TourPriceEx|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TourPriceEx
     */
    public function getAttributeName()
    {
        return 'TourPriceEx';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTourPriceEx
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
