<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetData' => '\\StructType\\GetData',
            'GetDataResponse' => '\\StructType\\GetDataResponse',
            'GetDataDistinctHotels' => '\\StructType\\GetDataDistinctHotels',
            'GetDataDistinctHotelsResponse' => '\\StructType\\GetDataDistinctHotelsResponse',
            'SearchTourGroupByHotel' => '\\StructType\\SearchTourGroupByHotel',
            'SearchTourGroupByHotelResponse' => '\\StructType\\SearchTourGroupByHotelResponse',
            'QuotaHotelsState' => '\\StructType\\QuotaHotelsState',
            'QuotaHotelsStateResponse' => '\\StructType\\QuotaHotelsStateResponse',
            'QuotaFlightsState' => '\\StructType\\QuotaFlightsState',
            'QuotaFlightsStateResponse' => '\\StructType\\QuotaFlightsStateResponse',
            'GetMinPrices' => '\\StructType\\GetMinPrices',
            'GetMinPricesResponse' => '\\StructType\\GetMinPricesResponse',
            'GetFilter' => '\\StructType\\GetFilter',
            'GetFilterResponse' => '\\StructType\\GetFilterResponse',
            'GetFilter2' => '\\StructType\\GetFilter2',
            'GetFilter2Response' => '\\StructType\\GetFilter2Response',
            'GetFilter3' => '\\StructType\\GetFilter3',
            'GetFilter3Response' => '\\StructType\\GetFilter3Response',
            'GetFilter4' => '\\StructType\\GetFilter4',
            'GetFilter4Response' => '\\StructType\\GetFilter4Response',
            'GetFilter5' => '\\StructType\\GetFilter5',
            'GetFilter5Response' => '\\StructType\\GetFilter5Response',
            'GetCountries' => '\\StructType\\GetCountries',
            'GetCountriesResponse' => '\\StructType\\GetCountriesResponse',
            'GetTourDirections' => '\\StructType\\GetTourDirections',
            'GetTourDirectionsResponse' => '\\StructType\\GetTourDirectionsResponse',
            'GetCityDeparture' => '\\StructType\\GetCityDeparture',
            'GetCityDepartureResponse' => '\\StructType\\GetCityDepartureResponse',
            'GetCityDepartureByTypeTour' => '\\StructType\\GetCityDepartureByTypeTour',
            'GetCityDepartureByTypeTourResponse' => '\\StructType\\GetCityDepartureByTypeTourResponse',
            'GetBaseDictionary' => '\\StructType\\GetBaseDictionary',
            'GetBaseDictionaryResponse' => '\\StructType\\GetBaseDictionaryResponse',
            'GetDictionary' => '\\StructType\\GetDictionary',
            'GetDictionaryResponse' => '\\StructType\\GetDictionaryResponse',
            'GetDictionaries' => '\\StructType\\GetDictionaries',
            'GetDictionariesResponse' => '\\StructType\\GetDictionariesResponse',
            'GetStat' => '\\StructType\\GetStat',
            'GetStatResponse' => '\\StructType\\GetStatResponse',
            'GetCourse' => '\\StructType\\GetCourse',
            'GetCourseResponse' => '\\StructType\\GetCourseResponse',
            'GetPricesPerPax' => '\\StructType\\GetPricesPerPax',
            'GetPricesPerPaxResponse' => '\\StructType\\GetPricesPerPaxResponse',
            'GetTourDirectionList' => '\\StructType\\GetTourDirectionList',
            'GetTourDirectionListResponse' => '\\StructType\\GetTourDirectionListResponse',
            'FilterParametr' => '\\StructType\\FilterParametr',
            'FilterParametr.Diagnostic' => '\\StructType\\FilterParametr_Diagnostic',
            'SearchResult' => '\\StructType\\SearchResult',
            'ArrayOfTourPriceEx' => '\\ArrayType\\ArrayOfTourPriceEx',
            'TourPriceEx' => '\\StructType\\TourPriceEx',
            'ArrayOfFlightInfo' => '\\ArrayType\\ArrayOfFlightInfo',
            'FlightInfo' => '\\StructType\\FlightInfo',
            'HotelOfferVariants' => '\\StructType\\HotelOfferVariants',
            'ArrayOfTourPriceServiceInfo' => '\\ArrayType\\ArrayOfTourPriceServiceInfo',
            'TourPriceServiceInfo' => '\\StructType\\TourPriceServiceInfo',
            'SearchGroupHotelResult' => '\\StructType\\SearchGroupHotelResult',
            'ArrayOfTourHotelGroup' => '\\ArrayType\\ArrayOfTourHotelGroup',
            'TourHotelGroup' => '\\StructType\\TourHotelGroup',
            'Tour' => '\\StructType\\Tour',
            'ArrayOfTourHotelVariant' => '\\ArrayType\\ArrayOfTourHotelVariant',
            'TourHotelVariant' => '\\StructType\\TourHotelVariant',
            'ArrayOfQuotaHotelItem' => '\\ArrayType\\ArrayOfQuotaHotelItem',
            'QuotaHotelItem' => '\\StructType\\QuotaHotelItem',
            'ArrayOfQuotaHotelRoomVariant' => '\\ArrayType\\ArrayOfQuotaHotelRoomVariant',
            'QuotaHotelRoomVariant' => '\\StructType\\QuotaHotelRoomVariant',
            'ArrayOfQuotaDateState' => '\\ArrayType\\ArrayOfQuotaDateState',
            'QuotaDateState' => '\\StructType\\QuotaDateState',
            'ArrayOfQuotaFlightItem' => '\\ArrayType\\ArrayOfQuotaFlightItem',
            'QuotaFlightItem' => '\\StructType\\QuotaFlightItem',
            'ArrayOfQuotaFlightTariffs' => '\\ArrayType\\ArrayOfQuotaFlightTariffs',
            'QuotaFlightTariffs' => '\\StructType\\QuotaFlightTariffs',
            'ArrayOfQuotaFlightTariffState' => '\\ArrayType\\ArrayOfQuotaFlightTariffState',
            'QuotaFlightTariffState' => '\\StructType\\QuotaFlightTariffState',
            'FlightProgram' => '\\StructType\\FlightProgram',
            'ArrayOfFlightProgramItem' => '\\ArrayType\\ArrayOfFlightProgramItem',
            'FlightProgramItem' => '\\StructType\\FlightProgramItem',
            'ArrayOfFlightService' => '\\ArrayType\\ArrayOfFlightService',
            'FlightService' => '\\StructType\\FlightService',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfshort' => '\\ArrayType\\ArrayOfshort',
            'Hotel' => '\\StructType\\Hotel',
            'DictionaryBase' => '\\StructType\\DictionaryBase',
            'TypeTour' => '\\StructType\\TypeTour',
            'City' => '\\StructType\\City',
            'HotelCategory' => '\\StructType\\HotelCategory',
            'Meal' => '\\StructType\\Meal',
            'Country' => '\\StructType\\Country',
            'TourDate' => '\\StructType\\TourDate',
            'TouristCountDetail' => '\\StructType\\TouristCountDetail',
            'RoomCategory' => '\\StructType\\RoomCategory',
            'Rate' => '\\StructType\\Rate',
            'AirSeason' => '\\StructType\\AirSeason',
            'Charter' => '\\StructType\\Charter',
            'Tariff' => '\\StructType\\Tariff',
            'AirLine' => '\\StructType\\AirLine',
            'Airport' => '\\StructType\\Airport',
            'Aircraft' => '\\StructType\\Aircraft',
            'HotelRoom' => '\\StructType\\HotelRoom',
            'Accommodation' => '\\StructType\\Accommodation',
            'ArrayOfAccommodationAge' => '\\ArrayType\\ArrayOfAccommodationAge',
            'AccommodationAge' => '\\StructType\\AccommodationAge',
            'RoomType' => '\\StructType\\RoomType',
            'Transfer' => '\\StructType\\Transfer',
            'Transport' => '\\StructType\\Transport',
            'Service' => '\\StructType\\Service',
            'ServiceList' => '\\StructType\\ServiceList',
            'AddDescript1' => '\\StructType\\AddDescript1',
            'AddDescript2' => '\\StructType\\AddDescript2',
            'HotelGroup' => '\\StructType\\HotelGroup',
            'HotelFacility' => '\\StructType\\HotelFacility',
            'ArrayOfAccommodation' => '\\ArrayType\\ArrayOfAccommodation',
            'ArrayOfReturnObject' => '\\ArrayType\\ArrayOfReturnObject',
            'ReturnObject' => '\\StructType\\ReturnObject',
            'ArrayOfDictionaryBase' => '\\ArrayType\\ArrayOfDictionaryBase',
            'ArrayOfDictionaryEnum' => '\\ArrayType\\ArrayOfDictionaryEnum',
            'ArrayOfRealCourse' => '\\ArrayType\\ArrayOfRealCourse',
            'RealCourse' => '\\StructType\\RealCourse',
            'ArrayOfStatItem' => '\\ArrayType\\ArrayOfStatItem',
            'StatItem' => '\\StructType\\StatItem',
            'ArrayOfStatValue' => '\\ArrayType\\ArrayOfStatValue',
            'StatValue' => '\\StructType\\StatValue',
            'ArrayOfPriceListDataPerPax' => '\\ArrayType\\ArrayOfPriceListDataPerPax',
            'PriceListDataPerPax' => '\\StructType\\PriceListDataPerPax',
            'ArrayOfHotelPriceScheduleItem' => '\\ArrayType\\ArrayOfHotelPriceScheduleItem',
            'HotelPriceScheduleItem' => '\\StructType\\HotelPriceScheduleItem',
            'ArrayOfHotelRoomPrice' => '\\ArrayType\\ArrayOfHotelRoomPrice',
            'HotelRoomPrice' => '\\StructType\\HotelRoomPrice',
            'ArrayOfChildPrice' => '\\ArrayType\\ArrayOfChildPrice',
            'ChildPrice' => '\\StructType\\ChildPrice',
            'ArrayOfPricePerAccmd' => '\\ArrayType\\ArrayOfPricePerAccmd',
            'PricePerAccmd' => '\\StructType\\PricePerAccmd',
            'GetTourDirectionListRequest' => '\\StructType\\GetTourDirectionListRequest',
            'BaseRequest' => '\\StructType\\BaseRequest',
            'BaseResponse' => '\\StructType\\BaseResponse',
            'ArrayOfMessage' => '\\ArrayType\\ArrayOfMessage',
            'Message' => '\\StructType\\Message',
            'ArrayOfTourDirection' => '\\ArrayType\\ArrayOfTourDirection',
            'TourDirection' => '\\StructType\\TourDirection',
        );
    }
}
