<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelOfferVariants StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:HotelOfferVariants
 * @subpackage Structs
 */
class HotelOfferVariants extends AbstractStructBase
{
    /**
     * The BoardBasisVariants
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $BoardBasisVariants;
    /**
     * The RoomCategoryVariants
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $RoomCategoryVariants;
    /**
     * The RoomTypeVariants
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $RoomTypeVariants;
    /**
     * Constructor method for HotelOfferVariants
     * @uses HotelOfferVariants::setBoardBasisVariants()
     * @uses HotelOfferVariants::setRoomCategoryVariants()
     * @uses HotelOfferVariants::setRoomTypeVariants()
     * @param \ArrayType\ArrayOfint $boardBasisVariants
     * @param \ArrayType\ArrayOfint $roomCategoryVariants
     * @param \ArrayType\ArrayOfint $roomTypeVariants
     */
    public function __construct(\ArrayType\ArrayOfint $boardBasisVariants = null, \ArrayType\ArrayOfint $roomCategoryVariants = null, \ArrayType\ArrayOfint $roomTypeVariants = null)
    {
        $this
            ->setBoardBasisVariants($boardBasisVariants)
            ->setRoomCategoryVariants($roomCategoryVariants)
            ->setRoomTypeVariants($roomTypeVariants);
    }
    /**
     * Get BoardBasisVariants value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getBoardBasisVariants()
    {
        return isset($this->BoardBasisVariants) ? $this->BoardBasisVariants : null;
    }
    /**
     * Set BoardBasisVariants value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $boardBasisVariants
     * @return \StructType\HotelOfferVariants
     */
    public function setBoardBasisVariants(\ArrayType\ArrayOfint $boardBasisVariants = null)
    {
        if (is_null($boardBasisVariants) || (is_array($boardBasisVariants) && empty($boardBasisVariants))) {
            unset($this->BoardBasisVariants);
        } else {
            $this->BoardBasisVariants = $boardBasisVariants;
        }
        return $this;
    }
    /**
     * Get RoomCategoryVariants value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getRoomCategoryVariants()
    {
        return isset($this->RoomCategoryVariants) ? $this->RoomCategoryVariants : null;
    }
    /**
     * Set RoomCategoryVariants value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $roomCategoryVariants
     * @return \StructType\HotelOfferVariants
     */
    public function setRoomCategoryVariants(\ArrayType\ArrayOfint $roomCategoryVariants = null)
    {
        if (is_null($roomCategoryVariants) || (is_array($roomCategoryVariants) && empty($roomCategoryVariants))) {
            unset($this->RoomCategoryVariants);
        } else {
            $this->RoomCategoryVariants = $roomCategoryVariants;
        }
        return $this;
    }
    /**
     * Get RoomTypeVariants value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getRoomTypeVariants()
    {
        return isset($this->RoomTypeVariants) ? $this->RoomTypeVariants : null;
    }
    /**
     * Set RoomTypeVariants value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $roomTypeVariants
     * @return \StructType\HotelOfferVariants
     */
    public function setRoomTypeVariants(\ArrayType\ArrayOfint $roomTypeVariants = null)
    {
        if (is_null($roomTypeVariants) || (is_array($roomTypeVariants) && empty($roomTypeVariants))) {
            unset($this->RoomTypeVariants);
        } else {
            $this->RoomTypeVariants = $roomTypeVariants;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HotelOfferVariants
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
