<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for QuotaFlightsState StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:QuotaFlightsState
 * @subpackage Structs
 */
class QuotaFlightsState extends AbstractStructBase
{
    /**
     * The filter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FilterParametr
     */
    public $filter;
    /**
     * The QuotaBackFlightItems
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfQuotaFlightItem
     */
    public $QuotaBackFlightItems;
    /**
     * The QuotaFlightItems
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfQuotaFlightItem
     */
    public $QuotaFlightItems;
    /**
     * Constructor method for QuotaFlightsState
     * @uses QuotaFlightsState::setFilter()
     * @uses QuotaFlightsState::setQuotaBackFlightItems()
     * @uses QuotaFlightsState::setQuotaFlightItems()
     * @param \StructType\FilterParametr $filter
     * @param \ArrayType\ArrayOfQuotaFlightItem $quotaBackFlightItems
     * @param \ArrayType\ArrayOfQuotaFlightItem $quotaFlightItems
     */
    public function __construct(\StructType\FilterParametr $filter = null, \ArrayType\ArrayOfQuotaFlightItem $quotaBackFlightItems = null, \ArrayType\ArrayOfQuotaFlightItem $quotaFlightItems = null)
    {
        $this
            ->setFilter($filter)
            ->setQuotaBackFlightItems($quotaBackFlightItems)
            ->setQuotaFlightItems($quotaFlightItems);
    }
    /**
     * Get filter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FilterParametr|null
     */
    public function getFilter()
    {
        return isset($this->filter) ? $this->filter : null;
    }
    /**
     * Set filter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\FilterParametr $filter
     * @return \StructType\QuotaFlightsState
     */
    public function setFilter(\StructType\FilterParametr $filter = null)
    {
        if (is_null($filter) || (is_array($filter) && empty($filter))) {
            unset($this->filter);
        } else {
            $this->filter = $filter;
        }
        return $this;
    }
    /**
     * Get QuotaBackFlightItems value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfQuotaFlightItem|null
     */
    public function getQuotaBackFlightItems()
    {
        return isset($this->QuotaBackFlightItems) ? $this->QuotaBackFlightItems : null;
    }
    /**
     * Set QuotaBackFlightItems value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfQuotaFlightItem $quotaBackFlightItems
     * @return \StructType\QuotaFlightsState
     */
    public function setQuotaBackFlightItems(\ArrayType\ArrayOfQuotaFlightItem $quotaBackFlightItems = null)
    {
        if (is_null($quotaBackFlightItems) || (is_array($quotaBackFlightItems) && empty($quotaBackFlightItems))) {
            unset($this->QuotaBackFlightItems);
        } else {
            $this->QuotaBackFlightItems = $quotaBackFlightItems;
        }
        return $this;
    }
    /**
     * Get QuotaFlightItems value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfQuotaFlightItem|null
     */
    public function getQuotaFlightItems()
    {
        return isset($this->QuotaFlightItems) ? $this->QuotaFlightItems : null;
    }
    /**
     * Set QuotaFlightItems value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfQuotaFlightItem $quotaFlightItems
     * @return \StructType\QuotaFlightsState
     */
    public function setQuotaFlightItems(\ArrayType\ArrayOfQuotaFlightItem $quotaFlightItems = null)
    {
        if (is_null($quotaFlightItems) || (is_array($quotaFlightItems) && empty($quotaFlightItems))) {
            unset($this->QuotaFlightItems);
        } else {
            $this->QuotaFlightItems = $quotaFlightItems;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\QuotaFlightsState
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
