<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Service StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Service
 * @subpackage Structs
 */
class Service extends DictionaryBase
{
    /**
     * The IsCity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsCity;
    /**
     * The IsSubKey
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsSubKey;
    /**
     * The IsSubKey1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsSubKey1;
    /**
     * The IsSubKey2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsSubKey2;
    /**
     * Constructor method for Service
     * @uses Service::setIsCity()
     * @uses Service::setIsSubKey()
     * @uses Service::setIsSubKey1()
     * @uses Service::setIsSubKey2()
     * @param bool $isCity
     * @param bool $isSubKey
     * @param bool $isSubKey1
     * @param bool $isSubKey2
     */
    public function __construct($isCity = null, $isSubKey = null, $isSubKey1 = null, $isSubKey2 = null)
    {
        $this
            ->setIsCity($isCity)
            ->setIsSubKey($isSubKey)
            ->setIsSubKey1($isSubKey1)
            ->setIsSubKey2($isSubKey2);
    }
    /**
     * Get IsCity value
     * @return bool|null
     */
    public function getIsCity()
    {
        return $this->IsCity;
    }
    /**
     * Set IsCity value
     * @param bool $isCity
     * @return \StructType\Service
     */
    public function setIsCity($isCity = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCity) && !is_bool($isCity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCity, true), gettype($isCity)), __LINE__);
        }
        $this->IsCity = $isCity;
        return $this;
    }
    /**
     * Get IsSubKey value
     * @return bool|null
     */
    public function getIsSubKey()
    {
        return $this->IsSubKey;
    }
    /**
     * Set IsSubKey value
     * @param bool $isSubKey
     * @return \StructType\Service
     */
    public function setIsSubKey($isSubKey = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSubKey) && !is_bool($isSubKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSubKey, true), gettype($isSubKey)), __LINE__);
        }
        $this->IsSubKey = $isSubKey;
        return $this;
    }
    /**
     * Get IsSubKey1 value
     * @return bool|null
     */
    public function getIsSubKey1()
    {
        return $this->IsSubKey1;
    }
    /**
     * Set IsSubKey1 value
     * @param bool $isSubKey1
     * @return \StructType\Service
     */
    public function setIsSubKey1($isSubKey1 = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSubKey1) && !is_bool($isSubKey1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSubKey1, true), gettype($isSubKey1)), __LINE__);
        }
        $this->IsSubKey1 = $isSubKey1;
        return $this;
    }
    /**
     * Get IsSubKey2 value
     * @return bool|null
     */
    public function getIsSubKey2()
    {
        return $this->IsSubKey2;
    }
    /**
     * Set IsSubKey2 value
     * @param bool $isSubKey2
     * @return \StructType\Service
     */
    public function setIsSubKey2($isSubKey2 = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSubKey2) && !is_bool($isSubKey2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSubKey2, true), gettype($isSubKey2)), __LINE__);
        }
        $this->IsSubKey2 = $isSubKey2;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Service
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
