<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceList StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ServiceList
 * @subpackage Structs
 */
class ServiceList extends DictionaryBase
{
    /**
     * The SvKey
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $SvKey;
    /**
     * The СityKey
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $СityKey;
    /**
     * The СountryKey
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $СountryKey;
    /**
     * Constructor method for ServiceList
     * @uses ServiceList::setSvKey()
     * @uses ServiceList::setСityKey()
     * @uses ServiceList::setСountryKey()
     * @param int $svKey
     * @param int $СityKey
     * @param int $СountryKey
     */
    public function __construct($svKey = null, $СityKey = null, $СountryKey = null)
    {
        $this
            ->setSvKey($svKey)
            ->setСityKey($СityKey)
            ->setСountryKey($СountryKey);
    }
    /**
     * Get SvKey value
     * @return int|null
     */
    public function getSvKey()
    {
        return $this->SvKey;
    }
    /**
     * Set SvKey value
     * @param int $svKey
     * @return \StructType\ServiceList
     */
    public function setSvKey($svKey = null)
    {
        // validation for constraint: int
        if (!is_null($svKey) && !(is_int($svKey) || ctype_digit($svKey))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($svKey, true), gettype($svKey)), __LINE__);
        }
        $this->SvKey = $svKey;
        return $this;
    }
    /**
     * Get СityKey value
     * @return int|null
     */
    public function getСityKey()
    {
        return $this->СityKey;
    }
    /**
     * Set СityKey value
     * @param int $СityKey
     * @return \StructType\ServiceList
     */
    public function setСityKey($СityKey = null)
    {
        // validation for constraint: int
        if (!is_null($СityKey) && !(is_int($СityKey) || ctype_digit($СityKey))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($СityKey, true), gettype($СityKey)), __LINE__);
        }
        $this->СityKey = $СityKey;
        return $this;
    }
    /**
     * Get СountryKey value
     * @return int|null
     */
    public function getСountryKey()
    {
        return $this->СountryKey;
    }
    /**
     * Set СountryKey value
     * @param int $СountryKey
     * @return \StructType\ServiceList
     */
    public function setСountryKey($СountryKey = null)
    {
        // validation for constraint: int
        if (!is_null($СountryKey) && !(is_int($СountryKey) || ctype_digit($СountryKey))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($СountryKey, true), gettype($СountryKey)), __LINE__);
        }
        $this->СountryKey = $СountryKey;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServiceList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
