<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TouristCountDetail StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TouristCountDetail
 * @subpackage Structs
 */
class TouristCountDetail extends DictionaryBase
{
    /**
     * The MaxAdult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $MaxAdult;
    /**
     * The MaxChild
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $MaxChild;
    /**
     * Constructor method for TouristCountDetail
     * @uses TouristCountDetail::setMaxAdult()
     * @uses TouristCountDetail::setMaxChild()
     * @param int $maxAdult
     * @param int $maxChild
     */
    public function __construct($maxAdult = null, $maxChild = null)
    {
        $this
            ->setMaxAdult($maxAdult)
            ->setMaxChild($maxChild);
    }
    /**
     * Get MaxAdult value
     * @return int|null
     */
    public function getMaxAdult()
    {
        return $this->MaxAdult;
    }
    /**
     * Set MaxAdult value
     * @param int $maxAdult
     * @return \StructType\TouristCountDetail
     */
    public function setMaxAdult($maxAdult = null)
    {
        // validation for constraint: int
        if (!is_null($maxAdult) && !(is_int($maxAdult) || ctype_digit($maxAdult))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxAdult, true), gettype($maxAdult)), __LINE__);
        }
        $this->MaxAdult = $maxAdult;
        return $this;
    }
    /**
     * Get MaxChild value
     * @return int|null
     */
    public function getMaxChild()
    {
        return $this->MaxChild;
    }
    /**
     * Set MaxChild value
     * @param int $maxChild
     * @return \StructType\TouristCountDetail
     */
    public function setMaxChild($maxChild = null)
    {
        // validation for constraint: int
        if (!is_null($maxChild) && !(is_int($maxChild) || ctype_digit($maxChild))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxChild, true), gettype($maxChild)), __LINE__);
        }
        $this->MaxChild = $maxChild;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TouristCountDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
