<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Transport StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Transport
 * @subpackage Structs
 */
class Transport extends DictionaryBase
{
    /**
     * The Places
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Places;
    /**
     * Constructor method for Transport
     * @uses Transport::setPlaces()
     * @param int $places
     */
    public function __construct($places = null)
    {
        $this
            ->setPlaces($places);
    }
    /**
     * Get Places value
     * @return int|null
     */
    public function getPlaces()
    {
        return $this->Places;
    }
    /**
     * Set Places value
     * @param int $places
     * @return \StructType\Transport
     */
    public function setPlaces($places = null)
    {
        // validation for constraint: int
        if (!is_null($places) && !(is_int($places) || ctype_digit($places))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($places, true), gettype($places)), __LINE__);
        }
        $this->Places = $places;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Transport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
